diff --git a/src/backend/storage/ipc/procarray.c b/src/backend/storage/ipc/procarray.c
new file mode 100644
index dfddfc4..9297960
*** a/src/backend/storage/ipc/procarray.c
--- b/src/backend/storage/ipc/procarray.c
*************** ProcArrayApplyRecoveryInfo(RunningTransa
*** 733,739 ****
  			else
  				elog(trace_recovery(DEBUG1),
  				  "recovery snapshot waiting for non-overflowed snapshot or "
! 				"until oldest active xid on standby is at least %u (now %u)",
  					 standbySnapshotPendingXmin,
  					 running->oldestRunningXid);
  			return;
--- 733,739 ----
  			else
  				elog(trace_recovery(DEBUG1),
  				  "recovery snapshot waiting for non-overflowed snapshot or "
! 				"until oldest active xid on standby is at least " XID_FMT " (now " XID_FMT ")",
  					 standbySnapshotPendingXmin,
  					 running->oldestRunningXid);
  			return;
*************** ProcArrayApplyRecoveryInfo(RunningTransa
*** 901,907 ****
  	else
  		elog(trace_recovery(DEBUG1),
  			 "recovery snapshot waiting for non-overflowed snapshot or "
! 			 "until oldest active xid on standby is at least %u (now %u)",
  			 standbySnapshotPendingXmin,
  			 running->oldestRunningXid);
  }
--- 901,907 ----
  	else
  		elog(trace_recovery(DEBUG1),
  			 "recovery snapshot waiting for non-overflowed snapshot or "
! 			 "until oldest active xid on standby is at least " XID_FMT " (now " XID_FMT ")",
  			 standbySnapshotPendingXmin,
  			 running->oldestRunningXid);
  }
*************** XidCacheRemoveRunningXids(TransactionId 
*** 3056,3062 ****
  		 * debug warning.
  		 */
  		if (j < 0 && !MyPgXact->overflowed)
! 			elog(WARNING, "did not find subXID %u in MyProc", anxid);
  	}
  
  	for (j = MyPgXact->nxids - 1; j >= 0; j--)
--- 3056,3062 ----
  		 * debug warning.
  		 */
  		if (j < 0 && !MyPgXact->overflowed)
! 			elog(WARNING, "did not find subXID " XID_FMT " in MyProc", anxid);
  	}
  
  	for (j = MyPgXact->nxids - 1; j >= 0; j--)
*************** XidCacheRemoveRunningXids(TransactionId 
*** 3069,3075 ****
  	}
  	/* Ordinarily we should have found it, unless the cache has overflowed */
  	if (j < 0 && !MyPgXact->overflowed)
! 		elog(WARNING, "did not find subXID %u in MyProc", xid);
  
  	/* Also advance global latestCompletedXid while holding the lock */
  	if (TransactionIdPrecedes(ShmemVariableCache->latestCompletedXid,
--- 3069,3075 ----
  	}
  	/* Ordinarily we should have found it, unless the cache has overflowed */
  	if (j < 0 && !MyPgXact->overflowed)
! 		elog(WARNING, "did not find subXID " XID_FMT " in MyProc", xid);
  
  	/* Also advance global latestCompletedXid while holding the lock */
  	if (TransactionIdPrecedes(ShmemVariableCache->latestCompletedXid,
*************** RecordKnownAssignedTransactionIds(Transa
*** 3175,3181 ****
  	Assert(TransactionIdIsValid(xid));
  	Assert(TransactionIdIsValid(latestObservedXid));
  
! 	elog(trace_recovery(DEBUG4), "record known xact %u latestObservedXid %u",
  		 xid, latestObservedXid);
  
  	/*
--- 3175,3181 ----
  	Assert(TransactionIdIsValid(xid));
  	Assert(TransactionIdIsValid(latestObservedXid));
  
! 	elog(trace_recovery(DEBUG4), "record known xact " XID_FMT " latestObservedXid " XID_FMT,
  		 xid, latestObservedXid);
  
  	/*
*************** KnownAssignedXidsRemove(TransactionId xi
*** 3675,3681 ****
  {
  	Assert(TransactionIdIsValid(xid));
  
! 	elog(trace_recovery(DEBUG4), "remove KnownAssignedXid %u", xid);
  
  	/*
  	 * Note: we cannot consider it an error to remove an XID that's not
--- 3675,3681 ----
  {
  	Assert(TransactionIdIsValid(xid));
  
! 	elog(trace_recovery(DEBUG4), "remove KnownAssignedXid " XID_FMT, xid);
  
  	/*
  	 * Note: we cannot consider it an error to remove an XID that's not
*************** KnownAssignedXidsRemovePreceding(Transac
*** 3736,3742 ****
  		return;
  	}
  
! 	elog(trace_recovery(DEBUG4), "prune KnownAssignedXids to %u", removeXid);
  
  	/*
  	 * Mark entries invalid starting at the tail.  Since array is sorted, we
--- 3736,3742 ----
  		return;
  	}
  
! 	elog(trace_recovery(DEBUG4), "prune KnownAssignedXids to " XID_FMT, removeXid);
  
  	/*
  	 * Mark entries invalid starting at the tail.  Since array is sorted, we
*************** KnownAssignedXidsDisplay(int trace_level
*** 3925,3931 ****
  		if (KnownAssignedXidsValid[i])
  		{
  			nxids++;
! 			appendStringInfo(&buf, "[%d]=%u ", i, KnownAssignedXids[i]);
  		}
  	}
  
--- 3925,3931 ----
  		if (KnownAssignedXidsValid[i])
  		{
  			nxids++;
! 			appendStringInfo(&buf, "[%d]=" XID_FMT " ", i, KnownAssignedXids[i]);
  		}
  	}
  
diff --git a/src/backend/storage/ipc/standby.c b/src/backend/storage/ipc/standby.c
new file mode 100644
index 8e57f93..a1b0026
*** a/src/backend/storage/ipc/standby.c
--- b/src/backend/storage/ipc/standby.c
***************
*** 34,40 ****
  #include "utils/timestamp.h"
  
  /* User-settable GUC parameters */
! int			vacuum_defer_cleanup_age;
  int			max_standby_archive_delay = 30 * 1000;
  int			max_standby_streaming_delay = 30 * 1000;
  
--- 34,40 ----
  #include "utils/timestamp.h"
  
  /* User-settable GUC parameters */
! int64		vacuum_defer_cleanup_age;
  int			max_standby_archive_delay = 30 * 1000;
  int			max_standby_streaming_delay = 30 * 1000;
  
*************** StandbyReleaseLocks(TransactionId xid)
*** 649,660 ****
  			LOCKTAG		locktag;
  
  			elog(trace_recovery(DEBUG4),
! 				 "releasing recovery lock: xid %u db %u rel %u",
  				 lock->xid, lock->dbOid, lock->relOid);
  			SET_LOCKTAG_RELATION(locktag, lock->dbOid, lock->relOid);
  			if (!LockRelease(&locktag, AccessExclusiveLock, true))
  				elog(LOG,
! 					 "RecoveryLockList contains entry for lock no longer recorded by lock manager: xid %u database %u relation %u",
  					 lock->xid, lock->dbOid, lock->relOid);
  
  			RecoveryLockList = list_delete_cell(RecoveryLockList, cell, prev);
--- 649,660 ----
  			LOCKTAG		locktag;
  
  			elog(trace_recovery(DEBUG4),
! 				 "releasing recovery lock: xid " XID_FMT " db %u rel %u",
  				 lock->xid, lock->dbOid, lock->relOid);
  			SET_LOCKTAG_RELATION(locktag, lock->dbOid, lock->relOid);
  			if (!LockRelease(&locktag, AccessExclusiveLock, true))
  				elog(LOG,
! 					 "RecoveryLockList contains entry for lock no longer recorded by lock manager: xid " XID_FMT " database %u relation %u",
  					 lock->xid, lock->dbOid, lock->relOid);
  
  			RecoveryLockList = list_delete_cell(RecoveryLockList, cell, prev);
*************** StandbyReleaseAllLocks(void)
*** 704,715 ****
  		next = lnext(cell);
  
  		elog(trace_recovery(DEBUG4),
! 			 "releasing recovery lock: xid %u db %u rel %u",
  			 lock->xid, lock->dbOid, lock->relOid);
  		SET_LOCKTAG_RELATION(locktag, lock->dbOid, lock->relOid);
  		if (!LockRelease(&locktag, AccessExclusiveLock, true))
  			elog(LOG,
! 				 "RecoveryLockList contains entry for lock no longer recorded by lock manager: xid %u database %u relation %u",
  				 lock->xid, lock->dbOid, lock->relOid);
  		RecoveryLockList = list_delete_cell(RecoveryLockList, cell, prev);
  		pfree(lock);
--- 704,715 ----
  		next = lnext(cell);
  
  		elog(trace_recovery(DEBUG4),
! 			 "releasing recovery lock: xid " XID_FMT " db %u rel %u",
  			 lock->xid, lock->dbOid, lock->relOid);
  		SET_LOCKTAG_RELATION(locktag, lock->dbOid, lock->relOid);
  		if (!LockRelease(&locktag, AccessExclusiveLock, true))
  			elog(LOG,
! 				 "RecoveryLockList contains entry for lock no longer recorded by lock manager: xid " XID_FMT " database %u relation %u",
  				 lock->xid, lock->dbOid, lock->relOid);
  		RecoveryLockList = list_delete_cell(RecoveryLockList, cell, prev);
  		pfree(lock);
*************** StandbyReleaseOldLocks(int nxids, Transa
*** 765,776 ****
  		if (remove)
  		{
  			elog(trace_recovery(DEBUG4),
! 				 "releasing recovery lock: xid %u db %u rel %u",
  				 lock->xid, lock->dbOid, lock->relOid);
  			SET_LOCKTAG_RELATION(locktag, lock->dbOid, lock->relOid);
  			if (!LockRelease(&locktag, AccessExclusiveLock, true))
  				elog(LOG,
! 					 "RecoveryLockList contains entry for lock no longer recorded by lock manager: xid %u database %u relation %u",
  					 lock->xid, lock->dbOid, lock->relOid);
  			RecoveryLockList = list_delete_cell(RecoveryLockList, cell, prev);
  			pfree(lock);
--- 765,776 ----
  		if (remove)
  		{
  			elog(trace_recovery(DEBUG4),
! 				 "releasing recovery lock: xid " XID_FMT " db %u rel %u",
  				 lock->xid, lock->dbOid, lock->relOid);
  			SET_LOCKTAG_RELATION(locktag, lock->dbOid, lock->relOid);
  			if (!LockRelease(&locktag, AccessExclusiveLock, true))
  				elog(LOG,
! 					 "RecoveryLockList contains entry for lock no longer recorded by lock manager: xid " XID_FMT " database %u relation %u",
  					 lock->xid, lock->dbOid, lock->relOid);
  			RecoveryLockList = list_delete_cell(RecoveryLockList, cell, prev);
  			pfree(lock);
*************** LogCurrentRunningXacts(RunningTransactio
*** 992,998 ****
  
  	if (CurrRunningXacts->subxid_overflow)
  		elog(trace_recovery(DEBUG2),
! 			 "snapshot of %u running transactions overflowed (lsn %X/%X oldest xid %u latest complete %u next xid %u)",
  			 CurrRunningXacts->xcnt,
  			 (uint32) (recptr >> 32), (uint32) recptr,
  			 CurrRunningXacts->oldestRunningXid,
--- 992,998 ----
  
  	if (CurrRunningXacts->subxid_overflow)
  		elog(trace_recovery(DEBUG2),
! 			 "snapshot of %u running transactions overflowed (lsn %X/%X oldest xid " XID_FMT " latest complete " XID_FMT " next xid " XID_FMT ")",
  			 CurrRunningXacts->xcnt,
  			 (uint32) (recptr >> 32), (uint32) recptr,
  			 CurrRunningXacts->oldestRunningXid,
*************** LogCurrentRunningXacts(RunningTransactio
*** 1000,1006 ****
  			 CurrRunningXacts->nextXid);
  	else
  		elog(trace_recovery(DEBUG2),
! 			 "snapshot of %u+%u running transaction ids (lsn %X/%X oldest xid %u latest complete %u next xid %u)",
  			 CurrRunningXacts->xcnt, CurrRunningXacts->subxcnt,
  			 (uint32) (recptr >> 32), (uint32) recptr,
  			 CurrRunningXacts->oldestRunningXid,
--- 1000,1006 ----
  			 CurrRunningXacts->nextXid);
  	else
  		elog(trace_recovery(DEBUG2),
! 			 "snapshot of %u+%u running transaction ids (lsn %X/%X oldest xid " XID_FMT " latest complete " XID_FMT " next xid " XID_FMT ")",
  			 CurrRunningXacts->xcnt, CurrRunningXacts->subxcnt,
  			 (uint32) (recptr >> 32), (uint32) recptr,
  			 CurrRunningXacts->oldestRunningXid,
diff --git a/src/backend/storage/lmgr/predicate.c b/src/backend/storage/lmgr/predicate.c
new file mode 100644
index bce505a..b2916b7
*** a/src/backend/storage/lmgr/predicate.c
--- b/src/backend/storage/lmgr/predicate.c
*************** static void SetPossibleUnsafeConflict(SE
*** 424,430 ****
  static void ReleaseRWConflict(RWConflict conflict);
  static void FlagSxactUnsafe(SERIALIZABLEXACT *sxact);
  
- static bool OldSerXidPagePrecedesLogically(int p, int q);
  static void OldSerXidInit(void);
  static void OldSerXidAdd(TransactionId xid, SerCommitSeqNo minConflictCommitSeqNo);
  static SerCommitSeqNo OldSerXidGetMinConflictCommitSeqNo(TransactionId xid);
--- 424,429 ----
*************** FlagSxactUnsafe(SERIALIZABLEXACT *sxact)
*** 765,796 ****
  	}
  }
  
- /*------------------------------------------------------------------------*/
- 
- /*
-  * We will work on the page range of 0..OLDSERXID_MAX_PAGE.
-  * Compares using wraparound logic, as is required by slru.c.
-  */
- static bool
- OldSerXidPagePrecedesLogically(int p, int q)
- {
- 	int			diff;
- 
- 	/*
- 	 * We have to compare modulo (OLDSERXID_MAX_PAGE+1)/2.  Both inputs should
- 	 * be in the range 0..OLDSERXID_MAX_PAGE.
- 	 */
- 	Assert(p >= 0 && p <= OLDSERXID_MAX_PAGE);
- 	Assert(q >= 0 && q <= OLDSERXID_MAX_PAGE);
- 
- 	diff = p - q;
- 	if (diff >= ((OLDSERXID_MAX_PAGE + 1) / 2))
- 		diff -= OLDSERXID_MAX_PAGE + 1;
- 	else if (diff < -((int) (OLDSERXID_MAX_PAGE + 1) / 2))
- 		diff += OLDSERXID_MAX_PAGE + 1;
- 	return diff < 0;
- }
- 
  /*
   * Initialize for the tracking of old serializable committed xids.
   */
--- 764,769 ----
*************** OldSerXidInit(void)
*** 802,808 ****
  	/*
  	 * Set up SLRU management of the pg_serial data.
  	 */
- 	OldSerXidSlruCtl->PagePrecedes = OldSerXidPagePrecedesLogically;
  	SimpleLruInit(OldSerXidSlruCtl, "oldserxid",
  				  NUM_OLDSERXID_BUFFERS, 0, OldSerXidLock, "pg_serial",
  				  LWTRANCHE_OLDSERXID_BUFFERS);
--- 775,780 ----
*************** OldSerXidAdd(TransactionId xid, SerCommi
*** 869,876 ****
  	else
  	{
  		firstZeroPage = OldSerXidNextPage(oldSerXidControl->headPage);
! 		isNewPage = OldSerXidPagePrecedesLogically(oldSerXidControl->headPage,
! 												   targetPage);
  	}
  
  	if (!TransactionIdIsValid(oldSerXidControl->headXid)
--- 841,847 ----
  	else
  	{
  		firstZeroPage = OldSerXidNextPage(oldSerXidControl->headPage);
! 		isNewPage = oldSerXidControl->headPage < targetPage;
  	}
  
  	if (!TransactionIdIsValid(oldSerXidControl->headXid)
*************** GetSerializableTransactionSnapshotInt(Sn
*** 1754,1760 ****
  		ereport(ERROR,
  				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
  				 errmsg("could not import the requested snapshot"),
! 			errdetail("The source process with pid %d is not running anymore.",
  						sourcepid)));
  	}
  
--- 1725,1731 ----
  		ereport(ERROR,
  				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
  				 errmsg("could not import the requested snapshot"),
! 			errdetail("The source process with pid %u is not running anymore.",
  						sourcepid)));
  	}
  
*************** PredicateLockTuple(Relation relation, He
*** 2541,2547 ****
  	{
  		TransactionId myxid;
  
! 		targetxmin = HeapTupleHeaderGetXmin(tuple->t_data);
  
  		myxid = GetTopTransactionIdIfAny();
  		if (TransactionIdIsValid(myxid))
--- 2512,2518 ----
  	{
  		TransactionId myxid;
  
! 		targetxmin = HeapTupleGetXmin(tuple);
  
  		myxid = GetTopTransactionIdIfAny();
  		if (TransactionIdIsValid(myxid))
*************** CheckForSerializableConflictOut(bool vis
*** 3963,3980 ****
  		case HEAPTUPLE_LIVE:
  			if (visible)
  				return;
! 			xid = HeapTupleHeaderGetXmin(tuple->t_data);
  			break;
  		case HEAPTUPLE_RECENTLY_DEAD:
  			if (!visible)
  				return;
! 			xid = HeapTupleHeaderGetUpdateXid(tuple->t_data);
  			break;
  		case HEAPTUPLE_DELETE_IN_PROGRESS:
! 			xid = HeapTupleHeaderGetUpdateXid(tuple->t_data);
  			break;
  		case HEAPTUPLE_INSERT_IN_PROGRESS:
! 			xid = HeapTupleHeaderGetXmin(tuple->t_data);
  			break;
  		case HEAPTUPLE_DEAD:
  			return;
--- 3934,3951 ----
  		case HEAPTUPLE_LIVE:
  			if (visible)
  				return;
! 			xid = HeapTupleGetXmin(tuple);
  			break;
  		case HEAPTUPLE_RECENTLY_DEAD:
  			if (!visible)
  				return;
! 			xid = HeapTupleGetUpdateXidAny(tuple);
  			break;
  		case HEAPTUPLE_DELETE_IN_PROGRESS:
! 			xid = HeapTupleGetUpdateXidAny(tuple);
  			break;
  		case HEAPTUPLE_INSERT_IN_PROGRESS:
! 			xid = HeapTupleGetXmin(tuple);
  			break;
  		case HEAPTUPLE_DEAD:
  			return;
*************** CheckForSerializableConflictOut(bool vis
*** 4035,4041 ****
  				ereport(ERROR,
  						(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
  						 errmsg("could not serialize access due to read/write dependencies among transactions"),
! 						 errdetail_internal("Reason code: Canceled on conflict out to old pivot %u.", xid),
  					  errhint("The transaction might succeed if retried.")));
  
  			if (SxactHasSummaryConflictIn(MySerializableXact)
--- 4006,4012 ----
  				ereport(ERROR,
  						(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
  						 errmsg("could not serialize access due to read/write dependencies among transactions"),
! 						 errdetail_internal("Reason code: Canceled on conflict out to old pivot " XID_FMT ".", xid),
  					  errhint("The transaction might succeed if retried.")));
  
  			if (SxactHasSummaryConflictIn(MySerializableXact)
*************** CheckForSerializableConflictOut(bool vis
*** 4043,4049 ****
  				ereport(ERROR,
  						(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
  						 errmsg("could not serialize access due to read/write dependencies among transactions"),
! 						 errdetail_internal("Reason code: Canceled on identification as a pivot, with conflict out to old committed transaction %u.", xid),
  					  errhint("The transaction might succeed if retried.")));
  
  			MySerializableXact->flags |= SXACT_FLAG_SUMMARY_CONFLICT_OUT;
--- 4014,4020 ----
  				ereport(ERROR,
  						(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
  						 errmsg("could not serialize access due to read/write dependencies among transactions"),
! 						 errdetail_internal("Reason code: Canceled on identification as a pivot, with conflict out to old committed transaction " XID_FMT ".", xid),
  					  errhint("The transaction might succeed if retried.")));
  
  			MySerializableXact->flags |= SXACT_FLAG_SUMMARY_CONFLICT_OUT;
*************** OnConflict_CheckForSerializationFailure(
*** 4670,4676 ****
  			ereport(ERROR,
  					(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
  					 errmsg("could not serialize access due to read/write dependencies among transactions"),
! 					 errdetail_internal("Reason code: Canceled on conflict out to pivot %u, during read.", writer->topXid),
  					 errhint("The transaction might succeed if retried.")));
  		}
  		writer->flags |= SXACT_FLAG_DOOMED;
--- 4641,4647 ----
  			ereport(ERROR,
  					(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
  					 errmsg("could not serialize access due to read/write dependencies among transactions"),
! 					 errdetail_internal("Reason code: Canceled on conflict out to pivot " XID_FMT ", during read.", writer->topXid),
  					 errhint("The transaction might succeed if retried.")));
  		}
  		writer->flags |= SXACT_FLAG_DOOMED;
diff --git a/src/backend/storage/page/bufpage.c b/src/backend/storage/page/bufpage.c
new file mode 100644
index 7187bd1..b51dd4a
*** a/src/backend/storage/page/bufpage.c
--- b/src/backend/storage/page/bufpage.c
***************
*** 20,25 ****
--- 20,26 ----
  #include "storage/checksum.h"
  #include "utils/memdebug.h"
  #include "utils/memutils.h"
+ #include "utils/snapmgr.h"
  
  
  /* GUC variable */
diff --git a/src/backend/utils/adt/enum.c b/src/backend/utils/adt/enum.c
new file mode 100644
index b1d2a6f..e5316cc
*** a/src/backend/utils/adt/enum.c
--- b/src/backend/utils/adt/enum.c
*************** check_safe_enum_use(HeapTuple enumval_tu
*** 71,77 ****
  	 * Usually, a row would get hinted as committed when it's read or loaded
  	 * into syscache; but just in case not, let's check the xmin directly.
  	 */
! 	xmin = HeapTupleHeaderGetXmin(enumval_tup->t_data);
  	if (!TransactionIdIsInProgress(xmin) &&
  		TransactionIdDidCommit(xmin))
  		return;
--- 71,77 ----
  	 * Usually, a row would get hinted as committed when it's read or loaded
  	 * into syscache; but just in case not, let's check the xmin directly.
  	 */
! 	xmin = HeapTupleGetXmin(enumval_tup);
  	if (!TransactionIdIsInProgress(xmin) &&
  		TransactionIdDidCommit(xmin))
  		return;
*************** check_safe_enum_use(HeapTuple enumval_tu
*** 98,104 ****
  	 * think it's too new and throw an unnecessary error, but we won't allow
  	 * an unsafe case.)
  	 */
! 	if (xmin == HeapTupleHeaderGetXmin(enumtyp_tup->t_data) &&
  		!(enumtyp_tup->t_data->t_infomask & HEAP_UPDATED))
  	{
  		/* same (sub)transaction, so safe */
--- 98,104 ----
  	 * think it's too new and throw an unnecessary error, but we won't allow
  	 * an unsafe case.)
  	 */
! 	if (xmin == HeapTupleGetXmin(enumtyp_tup) &&
  		!(enumtyp_tup->t_data->t_infomask & HEAP_UPDATED))
  	{
  		/* same (sub)transaction, so safe */
diff --git a/src/backend/utils/adt/jsonfuncs.c b/src/backend/utils/adt/jsonfuncs.c
new file mode 100644
index d7ece68..53478e7
*** a/src/backend/utils/adt/jsonfuncs.c
--- b/src/backend/utils/adt/jsonfuncs.c
*************** populate_record(TupleDesc tupdesc,
*** 3070,3075 ****
--- 3070,3076 ----
  		tuple.t_len = HeapTupleHeaderGetDatumLength(defaultval);
  		ItemPointerSetInvalid(&(tuple.t_self));
  		tuple.t_tableOid = InvalidOid;
+ 		HeapTupleSetZeroBase(&tuple);
  		tuple.t_data = defaultval;
  
  		/* Break down the tuple into fields */
*************** populate_recordset_record(PopulateRecord
*** 3447,3452 ****
--- 3448,3454 ----
  	tuple.t_len = HeapTupleHeaderGetDatumLength(tuphead);
  	ItemPointerSetInvalid(&(tuple.t_self));
  	tuple.t_tableOid = InvalidOid;
+ 	HeapTupleSetZeroBase(&tuple);
  	tuple.t_data = tuphead;
  
  	tuplestore_puttuple(state->tuple_store, &tuple);
diff --git a/src/backend/utils/adt/lockfuncs.c b/src/backend/utils/adt/lockfuncs.c
new file mode 100644
index ef4824f..a38bf5f
*** a/src/backend/utils/adt/lockfuncs.c
--- b/src/backend/utils/adt/lockfuncs.c
*************** VXIDGetDatum(BackendId bid, LocalTransac
*** 67,75 ****
  	 * The representation is "<bid>/<lxid>", decimal and unsigned decimal
  	 * respectively.  Note that elog.c also knows how to format a vxid.
  	 */
! 	char		vxidstr[32];
  
! 	snprintf(vxidstr, sizeof(vxidstr), "%d/%u", bid, lxid);
  
  	return CStringGetTextDatum(vxidstr);
  }
--- 67,75 ----
  	 * The representation is "<bid>/<lxid>", decimal and unsigned decimal
  	 * respectively.  Note that elog.c also knows how to format a vxid.
  	 */
! 	char		vxidstr[64];
  
! 	snprintf(vxidstr, sizeof(vxidstr), "%d/" XID_FMT, bid, lxid);
  
  	return CStringGetTextDatum(vxidstr);
  }
*************** pg_lock_status(PG_FUNCTION_ARGS)
*** 269,275 ****
  				break;
  			case LOCKTAG_TRANSACTION:
  				values[6] =
! 					TransactionIdGetDatum(instance->locktag.locktag_field1);
  				nulls[1] = true;
  				nulls[2] = true;
  				nulls[3] = true;
--- 269,277 ----
  				break;
  			case LOCKTAG_TRANSACTION:
  				values[6] =
! 					TransactionIdGetDatum(
! 						(TransactionId)instance->locktag.locktag_field1 |
! 						((TransactionId)instance->locktag.locktag_field2 << 32));
  				nulls[1] = true;
  				nulls[2] = true;
  				nulls[3] = true;
*************** pg_lock_status(PG_FUNCTION_ARGS)
*** 281,287 ****
  				break;
  			case LOCKTAG_VIRTUALTRANSACTION:
  				values[5] = VXIDGetDatum(instance->locktag.locktag_field1,
! 										 instance->locktag.locktag_field2);
  				nulls[1] = true;
  				nulls[2] = true;
  				nulls[3] = true;
--- 283,290 ----
  				break;
  			case LOCKTAG_VIRTUALTRANSACTION:
  				values[5] = VXIDGetDatum(instance->locktag.locktag_field1,
! 										 (TransactionId)instance->locktag.locktag_field2 |
! 										((TransactionId)instance->locktag.locktag_field3 << 32));
  				nulls[1] = true;
  				nulls[2] = true;
  				nulls[3] = true;
diff --git a/src/backend/utils/adt/ri_triggers.c b/src/backend/utils/adt/ri_triggers.c
new file mode 100644
index 37139f9..ee25d7e
*** a/src/backend/utils/adt/ri_triggers.c
--- b/src/backend/utils/adt/ri_triggers.c
*************** RI_FKey_fk_upd_check_required(Trigger *t
*** 2170,2176 ****
  			 * UPDATE check.  (We could skip this if we knew the INSERT
  			 * trigger already fired, but there is no easy way to know that.)
  			 */
! 			if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmin(old_row->t_data)))
  				return true;
  
  			/* If all old and new key values are equal, no check is needed */
--- 2170,2176 ----
  			 * UPDATE check.  (We could skip this if we knew the INSERT
  			 * trigger already fired, but there is no easy way to know that.)
  			 */
! 			if (TransactionIdIsCurrentTransactionId(HeapTupleGetXmin(old_row)))
  				return true;
  
  			/* If all old and new key values are equal, no check is needed */
*************** RI_FKey_fk_upd_check_required(Trigger *t
*** 2208,2214 ****
  			 * UPDATE check.  (We could skip this if we knew the INSERT
  			 * trigger already fired, but there is no easy way to know that.)
  			 */
! 			if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmin(old_row->t_data)))
  				return true;
  
  			/* If all old and new key values are equal, no check is needed */
--- 2208,2214 ----
  			 * UPDATE check.  (We could skip this if we knew the INSERT
  			 * trigger already fired, but there is no easy way to know that.)
  			 */
! 			if (TransactionIdIsCurrentTransactionId(HeapTupleGetXmin(old_row)))
  				return true;
  
  			/* If all old and new key values are equal, no check is needed */
diff --git a/src/backend/utils/adt/rowtypes.c b/src/backend/utils/adt/rowtypes.c
new file mode 100644
index 08b37b2..ee54781
*** a/src/backend/utils/adt/rowtypes.c
--- b/src/backend/utils/adt/rowtypes.c
*************** record_out(PG_FUNCTION_ARGS)
*** 324,329 ****
--- 324,330 ----
  	tuple.t_len = HeapTupleHeaderGetDatumLength(rec);
  	ItemPointerSetInvalid(&(tuple.t_self));
  	tuple.t_tableOid = InvalidOid;
+ 	HeapTupleSetZeroBase(&tuple);
  	tuple.t_data = rec;
  
  	/*
*************** record_send(PG_FUNCTION_ARGS)
*** 669,674 ****
--- 670,676 ----
  	tuple.t_len = HeapTupleHeaderGetDatumLength(rec);
  	ItemPointerSetInvalid(&(tuple.t_self));
  	tuple.t_tableOid = InvalidOid;
+ 	HeapTupleSetZeroBase(&tuple);
  	tuple.t_data = rec;
  
  	/*
*************** record_cmp(FunctionCallInfo fcinfo)
*** 818,827 ****
--- 820,831 ----
  	tuple1.t_len = HeapTupleHeaderGetDatumLength(record1);
  	ItemPointerSetInvalid(&(tuple1.t_self));
  	tuple1.t_tableOid = InvalidOid;
+ 	HeapTupleSetZeroBase(&tuple1);
  	tuple1.t_data = record1;
  	tuple2.t_len = HeapTupleHeaderGetDatumLength(record2);
  	ItemPointerSetInvalid(&(tuple2.t_self));
  	tuple2.t_tableOid = InvalidOid;
+ 	HeapTupleSetZeroBase(&tuple2);
  	tuple2.t_data = record2;
  
  	/*
*************** record_eq(PG_FUNCTION_ARGS)
*** 1057,1066 ****
--- 1061,1072 ----
  	ItemPointerSetInvalid(&(tuple1.t_self));
  	tuple1.t_tableOid = InvalidOid;
  	tuple1.t_data = record1;
+ 	HeapTupleSetZeroBase(&tuple1);
  	tuple2.t_len = HeapTupleHeaderGetDatumLength(record2);
  	ItemPointerSetInvalid(&(tuple2.t_self));
  	tuple2.t_tableOid = InvalidOid;
  	tuple2.t_data = record2;
+ 	HeapTupleSetZeroBase(&tuple2);
  
  	/*
  	 * We arrange to look up the needed comparison info just once per series
*************** record_image_cmp(FunctionCallInfo fcinfo
*** 1316,1325 ****
--- 1322,1333 ----
  	ItemPointerSetInvalid(&(tuple1.t_self));
  	tuple1.t_tableOid = InvalidOid;
  	tuple1.t_data = record1;
+ 	HeapTupleSetZeroBase(&tuple1);
  	tuple2.t_len = HeapTupleHeaderGetDatumLength(record2);
  	ItemPointerSetInvalid(&(tuple2.t_self));
  	tuple2.t_tableOid = InvalidOid;
  	tuple2.t_data = record2;
+ 	HeapTupleSetZeroBase(&tuple2);
  
  	/*
  	 * We arrange to look up the needed comparison info just once per series
*************** record_image_eq(PG_FUNCTION_ARGS)
*** 1593,1602 ****
--- 1601,1612 ----
  	ItemPointerSetInvalid(&(tuple1.t_self));
  	tuple1.t_tableOid = InvalidOid;
  	tuple1.t_data = record1;
+ 	HeapTupleSetZeroBase(&tuple1);
  	tuple2.t_len = HeapTupleHeaderGetDatumLength(record2);
  	ItemPointerSetInvalid(&(tuple2.t_self));
  	tuple2.t_tableOid = InvalidOid;
  	tuple2.t_data = record2;
+ 	HeapTupleSetZeroBase(&tuple2);
  
  	/*
  	 * We arrange to look up the needed comparison info just once per series
